#!/usr/bin/perl -I/usr/sausalito/perl -I/usr/sausalito/handlers/base/shell
# $Id: vsite_shell.pl
#
# toggle shell access on and off for all site users when the vsite
#

use CCE;
use Base::User qw(usermod);
use MyShell;
use Base::Vsite qw(vsite_update_site_admin_caps);
use Base::HomeDir qw(homedir_get_group_dir);
use File::Temp;
use Sauce::Service;

# Debugging switch:
$DEBUG = "0";
if ($DEBUG) {
    use Sys::Syslog qw( :DEFAULT setlogsock);
    use Data::Dumper;
}

my $cce = new CCE;
$cce->connectfd();

my $vsite = $cce->event_object();
my ($ok, $shell) = $cce->get($cce->event_oid(), 'Shell');
if (!$ok) {
    $cce->bye('FAIL', '[[base-shell.cantReadVsiteShell]]');
    exit(1);
}

# if the vsite is suspended or shell is turned off, disable shell for
# all users
my @usermods = ();
my $fail_msg = '';

if ($vsite->{suspend}) {
    $shell->{enabled} eq "0";
}

#
### The Shawshank Redemption - Handles Jail creation:
#

&debug_msg("Warden Samuel Norton: The roof of the license-plate factory needs resurfacing. I need a dozen volunteers for a week's work. As you know, special detail carries with it special privileges.\n");

# Note to self: If /dev/log fails to create, then Systemd is fucked and needs a restart:
#system("systemctl restart systemd-journald.socket");
#system("systemctl restart rsyslog");

my $jailpresent = '0';
my $ret = '';

my $site_dir = homedir_get_group_dir($vsite->{name}, $vsite->{volume});
&andy_dufresne($site_dir, $shell, $cce, '0');

my $home_dir = homedir_get_group_dir($vsite->{name}, $vsite->{volume});
$home_dir = $site_dir . '/home';
&andy_dufresne($home_dir, $shell, $cce, '1');

&debug_msg("Warden Samuel Norton : If you wanna indulge in this fantasy, that's your business. Don't make it mine. This meeting is over.\n");

#
### Fin
#

# enable shell for all users, who have been given shell access
my @users = $cce->find('User', { 'site' => $vsite->{name} });
for my $oid (@users) {
    ($ok, my $user) = $cce->get($oid);
    ($ok, my $user_shell) = $cce->get($oid, 'Shell');
    if (!$ok) {
        &debug_msg("Fail: [[base-shell.cantReadVsiteUser]]\n");
        $cce->bye('FAIL', '[[base-shell.cantReadVsiteUser]]');
        exit(1);
    }

    &debug_msg("Vsite Shell: $shell->{enabled} - User '$user->{name}' Shell: $user_shell->{enabled}\n");
    if ($user_shell->{enabled} gt $shell->{enabled}) {
        &debug_msg("User '$user->{name}' needs Shell privilege reduction from $user_shell->{enabled} to $shell->{enabled}\n");
        ($ok) = $cce->set($oid, 'Shell', { 'enabled' => $shell->{enabled} } );
        if (!$ok) {
            &debug_msg("Fail: [[base-shell.cantmodifyVsiteUserShell]]\n");
            $cce->bye('FAIL', '[[base-shell.cantmodifyVsiteUserShell]]');
            exit(1);
        }

    }
} # got all site users

# update site admin caps
if (!$cce->event_is_destroy()) {
    vsite_update_site_admin_caps($cce, $vsite, 'siteShell', $shell->{enabled});
}

&debug_msg("Exit: SUCCESS\n");

$cce->bye('SUCCESS');
exit(0);

#
### Subroutines:
#

sub jailtrasher {
    my ($janitor_site_dir, $isHomeJail) = @_;
    &debug_msg("Removing Jail for $janitor_site_dir!\n");
    if (($janitor_site_dir ne "") && ($janitor_site_dir ne "/")) {
        my $binGone = $janitor_site_dir . '/bin';
        my $devGone = $janitor_site_dir . '/dev';
        my $etcGone = $janitor_site_dir . '/etc';
        my $libGone = $janitor_site_dir . '/lib64';
        my $tmpGone = $janitor_site_dir . '/tmp';
        my $usrGone = $janitor_site_dir . '/usr';
        my $runGone = $janitor_site_dir . '/run';
        my $varGone = $janitor_site_dir . '/var/tmp';
        system("rm -Rf $binGone");
        system("rm -Rf $devGone");
        system("rm -Rf $etcGone");
        system("rm -Rf $libGone");
        system("rm -Rf $tmpGone");
        system("rm -Rf $usrGone");
        system("rm -Rf $runGone");
        system("rm -Rf $varGone");

        if ($isHomeJail eq '1') {
            my $HomevarGone = $janitor_site_dir . '/var';
            &debug_msg("Removing $HomevarGone\n");
            system("rm -Rf $HomevarGone");
        }
    }
    else {
        &debug_msg("ERROR: $janitor_site_dir was empty or set to '/' - can't allow that!\n");
    }
}

sub get_temp_filename {
    my $fh = File::Temp->new(
        TEMPLATE => 'jailXXXXX',
        DIR      => '/usr/sausalito/jailer',
        SUFFIX   => '.sh',
    );

    return $fh->filename;
}

sub janitor {

    my $janitor_site_dir = shift;

    $helper_dir = '/usr/sausalito/jailer';
    if (! -d $helper_dir) {
        system("mkdir $helper_dir");
        system("chmod 700 $helper_dir");
        system("chown root:root $helper_dir");
    }

    $helper_out = "#!/bin/sh\n\n";
    $helper_out .= "/usr/sbin/jk_init -j $janitor_site_dir -k basicshell editors extendedshell netutils ssh sftp scp pico id logbasics jk_lsh &>/dev/null || :\n\n";
    $helper_out .= "exit\n";

    $filename = get_temp_filename();
    open(my $fh, '>', $filename);
    print $fh $helper_out;
    close $fh;

    system("chmod 700 $filename");
    system("chown root:root $filename");

    &debug_msg("Created: $filename with content to run '/usr/sbin/jk_init -j $janitor_site_dir -k basicshell editors extendedshell netutils ssh sftp scp pico id logbasics jk_lsh'\n");

    &debug_msg("Restarting Service 'jailer'\n");
    Sauce::Service::service_run_init('jailer', 'restart', 'nobg');
}

sub andy_dufresne {

    my ($site_dir, $shell, $cce, $isHomeJail) = @_;

    $fail_state = '0';

    if (! -d $site_dir) {
        &debug_msg("ERROR: $site_dir is not a directory!\n");
        $cce->bye('FAIL', '[[base-shell.cantReadDir]]');
        exit(1);
    }
    else {
        &debug_msg("Directory $site_dir exists.\n");
    }

    # Check if Jail is already there:
    if ((-f "$site_dir/etc/passwd") && (-x "$site_dir/usr/sbin/jk_lsh")) {
        $jailpresent = '1';
    }
    &debug_msg("site_dir: $site_dir - Shell Status: $shell->{enabled} - Jail present: $jailpresent - isHomeJail: $isHomeJail\n");

    if ((($shell->{enabled} eq "1") || ($shell->{enabled} eq "2") || ($shell->{enabled} eq "3")) && ($jailpresent eq "0")) {
        &debug_msg("Jail should be turned on for $site_dir!\n");
        # Making sure $site_dir is owned by root:root or jk_init will fail:
        &debug_msg("Running: chown root:root $site_dir\n");
        system("chown root:root $site_dir");
        # While we're at it also ebforce the correct permissions or jk_init will fail:
        &debug_msg("Running: chmod 0755 $site_dir\n");
        system("chmod 0755 $site_dir");

        # Create Jail:
        &janitor($site_dir);

        # Check if Jail was created properly:
        if ((-f "$site_dir/etc/passwd") && (-x "$site_dir/usr/sbin/jk_lsh")) {
            &debug_msg("jk_init failed for site_dir: $site_dir! - ret: $ret\n");
        }
    }
    elsif ((($shell->{enabled} eq "1") || ($shell->{enabled} eq "2") || ($shell->{enabled} eq "3")) && ($jailpresent eq "1")) {
        &debug_msg("Jail for $site_dir is already present. Good.!\n");
    }
    else {
        &debug_msg("Jail should be turned off for $site_dir!\n");

        #  Remove Jail content:
        &jailtrasher($site_dir, $isHomeJail);
    }
}

sub debug_msg {
    if ($DEBUG) {
        my $msg = shift;
        setlogsock('unix');
        openlog($0,'','user');
        syslog('info', "$ARGV[0]: $msg");
        closelog;
    }
}

# 
# Copyright (c) 2008-2023 Michael Stauber, SOLARSPEED.NET
# Copyright (c) 2008-2023 Team BlueOnyx, BLUEONYX.IT
# Copyright (c) 2003 Sun Microsystems, Inc. 
# All Rights Reserved.
# 
# 1. Redistributions of source code must retain the above copyright 
#    notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright 
#    notice, this list of conditions and the following disclaimer in 
#    the documentation and/or other materials provided with the 
#    distribution.
# 
# 3. Neither the name of the copyright holder nor the names of its 
#    contributors may be used to endorse or promote products derived 
#    from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
# 
# You acknowledge that this software is not designed or intended for 
# use in the design, construction, operation or maintenance of any 
# nuclear facility.
# 
